
package com.molino.ai;

/**
 * Representa un nodo en el espacio de busqueda del minimax, incluyendo puntuacion de busqueda
 *  y movimiento/estado
 *
 */
public class SearchNode<S extends Comparable> 
    implements Comparable
{
    public int score;
    public S state;
    
    public SearchNode()
    {        
    }
    
    public SearchNode(int score)
    {
        this.score = score;
    }

    public SearchNode(S state)
    {
        this.state = state;
    }

    public SearchNode(S state, int score)
    {
        this.state = state;
        this.score = score;
    }

    @Override
    public boolean equals(Object obj)
    {
        return state.equals(((SearchNode)obj).state);
    }

    @Override
    public int hashCode()
    {
        return state.hashCode();
    }

    @Override
    public String toString()
    {
        return state.toString()+" ($"+score+")";
    }

    public int compareTo(Object o)
    {
        return state.compareTo(((SearchNode)o).state);
    }  
}
