
package com.molino.ai;

/**
 *
 * Permite al cliente del algoritmo ab-minimax especificar
 * la estructura de datos para almacenar y recuperar transposiciones de busqueda.
 * 
 * Las transposiciones indican estados identicos alcanzados en diferentes puntos
 * en el espacio de busqueda. Los estados identicos tienen la misma puntuacion, 
 * asi que si son encontrados, no son evaluados mas adelante.
 * 
 */
public interface TranspositionTable<S extends Comparable>
{
    public void put(SearchNode<S> node);
    public SearchNode<S> get(SearchNode<S> node);
    public void reset();
}
