package com.molino.mills;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;

import org.apache.log4j.Logger;

import com.molino.mills.gui.MulinoPanel;

/**
 * La aplicacion principal de el molino.
 */
public class Molino extends javax.swing.JFrame
    implements ActionListener
{
    static Logger log = Logger.getLogger(Molino.class);
    
    private JMenuItem helpMenuItem;
    private JMenu jMenu5;
    private JMenuItem deleteMenuItem;
    private JSeparator jSeparator1;
    private JMenuItem pasteMenuItem;
    private JMenuItem undoMenuItem;
    /**
	 * @uml.property  name="nineMensMorrisPanel1"
	 * @uml.associationEnd  
	 */
    private MulinoPanel nineMensMorrisPanel1;
    private JMenuItem copyMenuItem;
    private JMenuItem cutMenuItem;
    private JMenu jMenu4;
    private JMenuItem exitMenuItem;
    private JSeparator jSeparator2;
    private JMenuItem closeFileMenuItem;
    private JMenuItem saveAsMenuItem;
    private JMenuItem saveMenuItem;
    private JMenuItem openFileMenuItem;
    private JMenuItem newGameMenuItem;
    private JMenu gameMenu;
    private JMenuBar jMenuBar1;

    private JPanel statusBarPane;

   /* BORRAR private JLabel copyrightLabel;*/

/*BORRAR    private JLabel courseLabel; */

    /**
    * Auto-generated main method to display this JFrame
    */
    public static void main(String[] args) {
        Molino inst = new Molino();
        inst.setVisible(true);
    }
    
    public Molino() {
        super();
        initGUI();
    }
    
    private void initGUI() {
        try {

            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

            BorderLayout thisLayout = new BorderLayout();
            getContentPane().setLayout(thisLayout);
            {
                nineMensMorrisPanel1 = new MulinoPanel();
                getContentPane().add(nineMensMorrisPanel1, BorderLayout.CENTER);
            }
            this.setResizable(false);
            this.setSize(567, 510);
            this.setPreferredSize(new java.awt.Dimension(567, 510));
            
            this.setTitle("Molino - El juego de mesa");
            {
                jMenuBar1 = new JMenuBar();
                setJMenuBar(jMenuBar1);
                {
                    gameMenu = new JMenu();
                    jMenuBar1.add(gameMenu);
                    gameMenu.setText("Juego");
                    gameMenu.addActionListener(nineMensMorrisPanel1);
                    {
                        newGameMenuItem = new JMenuItem();
                        gameMenu.add(newGameMenuItem);
                        newGameMenuItem.setText("Juego nuevo");
                        newGameMenuItem.setActionCommand("new");
                        newGameMenuItem.setToolTipText("Aborta el juego actual y empieza de nuevo.");
                        newGameMenuItem.setAccelerator(KeyStroke.getKeyStroke("ctrl N"));
                        newGameMenuItem.addActionListener(this);
                    }
                    {
                        undoMenuItem = new JMenuItem();
                        gameMenu.add(undoMenuItem);
                        undoMenuItem.setText("Vuelve atras el ultimo movimiento");
                        undoMenuItem.setAccelerator(KeyStroke.getKeyStroke("ctrl Z"));
                        undoMenuItem.setActionCommand("undo");
                        undoMenuItem.setToolTipText("Deshace el ultimo movimiento");
                        undoMenuItem.addActionListener(this);
                    }
                }
                {
                    statusBarPane = new JPanel();
                    BorderLayout statusBarPaneLayout = new BorderLayout();
                    statusBarPane.setLayout(statusBarPaneLayout);
                    getContentPane().add(statusBarPane, BorderLayout.SOUTH);
                    statusBarPane.setBounds(0, 413, 574, 21);
                    statusBarPane.setOpaque(false);
                    statusBarPane.setBorder(new SoftBevelBorder(BevelBorder.LOWERED, null, null, null, null));
                    statusBarPane.setPreferredSize(new java.awt.Dimension(559, 24));
                    {
                    }
                    {
                    }
                }

                addWindowListener(new ExitListener());
                
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void actionPerformed(ActionEvent e)
    {
        log.debug(e);
        if ( "new".equals(e.getActionCommand()) )
        {
            nineMensMorrisPanel1.getGameController().newGame();
        }
        else if ( "undo".equals(e.getActionCommand()) )
        {
            nineMensMorrisPanel1.getGameController().takeBackMove();            
        }
    }

}

class ExitListener extends WindowAdapter 
{
    public void windowClosing(WindowEvent event) 
    {
        System.exit(0);
    }
  }